To be Written...


# Email Copy/Paste
From my own email.

*Especially important to me is to support the development of the intuition that allows students to express their engineering needs semantically, and the curiosity to not simply take the "easy" way (at least, what seems easy ex. global variables and for..append), but to make a daily goal of exploring new ways to more elegantly express concepts using the available language tools. For fun, for some, but more importantly, so that all can create better behaved software tools to accomplish their own unique engineering goals.*

With those big words, here goes!
- `import this`: I think PEP 20 really sets the tone for the whole 'computational thinking' buzz. 10min evangelizing it is time well-spent. I think so, anyway :)
- `help(anything)` and `dir()`: Python's own help system is actually quite nice. People should know built-in help systems like this. It especially helps when trying to figure out what to google / cutting through too-dense library documentation.

Moving past day 1:
- `complex(real = 1, imag = 2)`: A godsend for any student checking their imaginary calculations.
- `range(10, -1, -1)`: That `range` is [s,e) with a direction too is strange at first, and this is a helpful explainer.
- `from pathlib import Path`: It's not immediately obvious what's wrong with `open("C:\Users\MrBean\...")`, until the TA tries to run the code. `pathlib` has been solving headaches since 2012's PEP 428.
- `{s % 2 for s in range(10)}`: Friends don't let friends `for...append`! Especially not when deduplication is desired!

As students get stronger:
- `with open(...) as f: ...`: `close()` has icky `free(*ptr)` vibes. `with` has such a nice mental model, which I feel everyone using Python deserves to be introduced to from the start.
- `settings_dict = tomllib.load(settings_file)`: Most people will need to configure their software one day. Config files are the lowest barrier to entry, and TOML is one of the simplest and least brittle. *Hopefully PEP 723 makes it through, in which case having met TOML will be even more vital!*
- `itertools.count`: That iterators can run forever, and that this is super useful, is one of those "aha" moments that I think is kind of important for everyone to get behind.
- `functools.lru_cache`: I've always found recursive `fibbonacci` a good little mind bender when unfamiliar with recursion. `lru_cache` makes it and other things fast! Plus, what better way to stimulate respect for caches than demonstrating how to abuse a simple one?

There are more, of course; `re` with regex101.com should be common knowledge, as should `shutil` for the more dangerous filesystem operations, `subprocess.run`, `print(file=<some_file_object>)`, and so on... It is all subjective anyway, but I hope this gave a nice overview of how I like to think about things.
